# c446_printkey.py 
# obj: cree une Hagelin de type C (M209, C446, ...)

import sys
from c446classes import *
import string

#============================================
#============================================
def restore( c, nomFichier ):
	if nomFichier == "":
		nomFichier = "config"
	f = open( nomFichier + ".key", "r" )
	for i in range(6):
		ch = f.readline()
		ch = ch.rstrip()
		lg = len(ch)
		for j in range(lg):
			if ch[j] != '_':
				c.setPinsON(i, ch[j] )
	ch = f.readline()
	ch = ch[0]
	c.setLetterShift( ch )

	ch = f.readline()
	ch = ch.rstrip()
	lesLugs = ch.split(":")
	lesLugs = map(int,lesLugs)
	c.setLugs( lesLugs )

	ch = f.readline()
	nblignes = int (ch )
	for i in range( nblignes ):
		ch = f.readline()
		ch = ch.rstrip()
		(over_clef, over_nb) = ch.split(":")
		over_nb = int(over_nb)
		c.setOverByKey(over_clef, over_nb)
	f.close()
#============================================
def importBlair( c, nomFichier ):
   #try:
	f = open( nomFichier, "r" )

	ch = ""
	while 1:
		ch = f.readline()
		# print ">>>=", ch, "[", ch[0] , "]"
		if ch[0] == ">": 
			break
		if ch == "": 
			raise IOError

	c.zero()
	wheels = []
	wheels.append( "ABCDEFGHIJKLMNOPQRSTUVWXYZ" )
	wheels.append( "ABCDEFGHIJKLMNOPQRSTUVXYZ" )
	wheels.append( "ABCDEFGHIJKLMNOPQRSTUVX" )
	wheels.append( "ABCDEFGHIJKLMNOPQRSTU" )
	wheels.append( "ABCDEFGHIJKLMNOPQRS" )
	wheels.append( "ABCDEFGHIJKLMNOPQ" )

	for i in range(6):
		
		ch = ch.rstrip()
		ch = ch[1:]
		lg = len(ch)
		for j in range(lg):
			if ch[j] == "1":
				c.setPinsON(i, wheels[i][j] )
		ch = f.readline()
		# print ch
		if ch == "": raise IOError
	
	c.setLetterShift( "Z" )

	ch = ch.rstrip()
	ch = ch[1:]
	lesBarres = ch.split(" ")
	# print "B: ", lesBarres
	lesLugs = [0] * 6

	o = { '1-2':0, '1-3':0, '1-4':0, '1-5':0, '1-6':0, '2-3':0,
		'2-4':0, '2-5':0, '2-6':0, '3-4':0, '3-5':0, '3-6':0,
		'4-5':0, '4-6':0, '5-6':0 }	
	for uneBarre in lesBarres:
		n1 = int( uneBarre[0] )
		n2 = int( uneBarre[1] )
		if n1 != 0: lesLugs[ n1 - 1 ] += 1
		if n2 != 0: lesLugs[ n2 - 1 ] += 1
		if n1 != 0 and n2 != 0: 
			cle = str(n1) + "-" + str(n2)
			o[cle] += 1

	c.setLugs( lesLugs )

	for x in sorted( o.keys() ):
		if o[x] > 0:		
			c.setOverByKey( x, o[x] )
	f.close()
	return ""
   #except:
	return "NO VALID KEY (27 bars,...)"
#============================================
def printKey( c ):
   try:
	lesPins = []
	for i in range( 6):
		lesPins.append( c.getPinsOfAWheel( i ) )
	tailleRoues = [ 26, 25, 23, 21, 19, 17 ]

	chWheels = []
	for i in range(27):
		ch = "     "
		for j in range(6):
			if i < tailleRoues[j]:
				ch +=  lesPins[j][i]
			else:
				ch +=  " " 
			ch += "  " 
		chWheels.append( ch )

	Lugs = c.getLugs()
	Over = c.getOver()
	Lugs2= list( Lugs )

	for x in sorted( Over.keys() ):
		if Over[x] > 0:
			#print x, Over[x],
			n1 = int( x[0] )
			n2 = int( x[2] )
			Lugs2[ n1 - 1 ] -= Over[x]
			Lugs2[ n2 - 1 ] -= Over[x]
			#print n1, n2
	chLugs = []
	n = 1
	for x in sorted( Over.keys() ):
		for i in range( Over[x] ):
			chLugs.append( "%02d: %s" % (n, x) )
			n += 1
	for i in range(6):
		if Lugs2[i] == 0: continue
		for j in range(Lugs2[i]):
			if i < 3:
				chLugs.append( "%02d: %1d-%1d" % ( n, i+1, 0) )
			else:
				chLugs.append( "%02d: %1d-%1d" % ( n, 0, i+1) )
			n += 1
	crypto = ""
	for i in range(26):
		if (i%5) == 0 and i != 0 : crypto += " "
		crypto += c.cipher("A")
	chResult = ""

	chResult += "-------------------------------" + '\n'
	chResult += "NR  LUGS    1  2  3  4  5  6" + '\n'
	chResult += "-------------------------------" + '\n'
	for i in range(27):
		chResult += chLugs[i] + chWheels[i] + '\n'
	chResult += "-------------------------------" + '\n'
	lettre = c.getLetterShift()
	chResult += "Shift: " + lettre + ",    26 letters Check:" + '\n'
	chResult += crypto + '\n'
	chResult += "-------------------------------" + '\n'
   except:
	chResult = "----- No valid key (27 bars, ...) ---- "
   finally:
	return chResult
#===========================================================
def exportBlair( c, f ):
	chResult = ""
	lesPins = []
	for i in range( 6):
		ch1 = c.getPinsOfAWheel( i ) 
		ch2 = ">"
		for j in range(len(ch1)):
			if ch1[j] == "_":
				ch2 += "0"
			else:
				ch2 += "1"
		ch2 += '\n'
		lesPins.append( ch2 )

	for i in range(6):
		f.write( lesPins[i] )

	Lugs = c.getLugs()
	Over = c.getOver()
	Lugs2= list( Lugs )

	ch = ">"
	for x in sorted( Over.keys() ):
		for i in range( Over[x] ):
			n1 = int( x[0] )
			n2 = int( x[2] )
			Lugs2[ n1 - 1 ] -= 1
			Lugs2[ n2 - 1 ] -= 1
			ch += "%1d%1d " % ( n1, n2 )
	
	for i in range(6):
		if Lugs2[i] == 0: continue
		for j in range(Lugs2[i]):
			if i < 3:
				ch += "%1d%1d " % ( i+1, 0) 
			else:
				ch += "%1d%1d " % ( 0, i+1) 
	ch += '\n'
	f.write( ch )

#===========================================================
if __name__ == "__main__":
	if len(sys.argv) < 2:
		print "Syntaxe: python c446_pkey.py cle  [import]"
		print "       don't write the extension (.key ou .m209key)"
		sys.exit(1)
	c = c446( "Z", 0)
	if len(sys.argv) > 2:
		importBlair( c, sys.argv[1] )
	else:
		KEYINTERN= sys.argv[1]
		restore(c, KEYINTERN)
	KEYEXTERN= "AAAAAA"
	c.setExternalKey(KEYEXTERN)
	print printKey( c )
	print 
	exportBlair( c, sys.stdout )
